<p>Hornerova shema (poznata još kao Hornerova metoda ili Hornerovo pravilo) je računski efikasniji algoritam za izračun sume oblika:
$$
\sum \limits_{i=0}^{n-1} a_i \cdot B^i
$$
Uzmimo za primjer oktalni broj 4375. Njegova vrijednost u dekadskom sustavu je:
$$
 4 \cdot 8^3 + 3 \cdot 8^2 + 7 \cdot 8^1 + 5 \cdot 8^0
$$
i da bismo to izračunali, trebamo izračunati sve napisane potencije broja 8. Taj se izraz međutim može izlučivanjem i grupiranjem baze prevesti u izraz u kojem nije potrebno računati niti jednu potenciju
baze. Evo kako:
$$
\begin{align}
 4 \cdot 8^3 + 3 \cdot 8^2 + 7 \cdot 8^1 + 5 \cdot 8^0 &amp;= 4 \cdot 8^3 + 3 \cdot 8^2 + 7 \cdot 8 + 5 \\
   &amp;= 8 \cdot (4 \cdot 8^2 + 3 \cdot 8 + 7) + 5 \\
   &amp;= 8 \cdot ( 8 \cdot (4 \cdot 8 + 3) + 7) + 5 \\
   &amp;= 8 \cdot ( 8 \cdot (8 \cdot (4) + 3) + 7) + 5 \\
\end{align}
$$
Pogledajte sada kakav je redoslijed operacija u ovom izrazu: čitamo od najdublje zagrade. Uzmemo znamenku najveće težine (to je 4) i to je trenutna vrijednost broja. Ako postoji sljedeća znamenka, 
trenutnu vrijednost broja pomnožimo s bazom i dodamo tu znamenku (to je onaj dio: \(8 \cdot (4) + 3\)) i to je nova vrijednost broja. Ako postoji sljedeća znamenka, trenutnu vrijednost broja pomnožimo
s bazom i dodamo tu znamenku. Postupak ponavljamo sve dok nismo "konzumirali" sve znamenke. Postupak možemo zapisati ovako. Neka je:
$$ b_n = a_n.$$
Preostale vrijednosti definiramo rekurzivnim izrazom:
$$ b_{i-1} = B \cdot b_i + a_{i-1}$$
</p>

<p>
U našem primjeru, to bi generiralo sljedeći niz brojeva. Radimo s oktalnim brojem 4375 koji ima znamenke \(a_3 a_2 a_1 a_0\). Postavljamo:
$$ b_3 = a_3 = 4.$$
Računamo dalje:
$$\begin{align}
  b_2 &amp;= B \cdot b_3 + a_2 = 8 \cdot 4 + 3 = 32 + 3 = 35 \\
  b_1 &amp;= B \cdot b_2 + a_1 = 8 \cdot 35 + 7 = 280 + 7 = 287 \\
  b_0 &amp;= B \cdot b_1 + a_0 = 8 \cdot 287 + 5 = 2296 + 5 = 2301 \\
\end{align}$$
čime dobivamo konačan rezultat: <span class="lang-constant">2301</span><sub>(10)</sub>.
</p>

<p>
Ovaj postupak izuzetno je zgodan za programsku implementaciju. Naime, ne trebamo pamtiti cijeli slijed brojeva \(b_i\) koje dobivamo već
je dovoljno pamtiti samo posljednji izračunati jer nam samo on treba za sljedeći (kojeg ćemo tada pamtiti umjesto ovog).
U proceduralnom programskom jeziku za to nam je dovoljna jedna varijabla. U nastavku je prikazana programska implementacija u jeziku C.</p>

<pre><code>#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;

int horner_pretvori(int* znamenke, int broj_znamenaka, int baza) {
  int i, tmp = znamenke[0];
  for(i = 1; i &lt; broj_znamenaka; i++) {
    tmp = baza * tmp + znamenke[i];
  }
  return tmp;
}

int main() {
  int znamenke[] = {4,3,7,5};
  int rezultat;
  
  rezultat = horner_pretvori(znamenke, 4, 8);
  printf("Dani oktalni broj u dekadskom brojevnom sustavu ima prikaz: %d\n", rezultat);
  return 0;
}</code></pre>

<p>Program možete pohraniti u datoteku <span class="filename">horner.c</span>, prevesti iz naredbenog retka:</p>

<pre><samp class="command-line">gcc horner.c</samp></pre>

<p>i potom pokrenuti. Na operacijskom sustavu Windows naredba bi bila:</p>

<pre><samp class="command-line">.\a.exe</samp></pre>

<p>a na operacijskom sustavu Linux:</p>

<pre><samp class="command-line">./a.out</samp></pre>

<p>Pokretanjem će se dobiti ispis prikazan u nastavku.</p>

<pre><samp class="program-output">Dani oktalni broj u dekadskom brojevnom sustavu ima prikaz: 2301</samp></pre>
